diff --git a/src/main/java/net/minecraft/core/player/inventory/slot/ArmorSlot.java b/src/main/java/net/minecraft/core/player/inventory/slot/SlotArmor.java
similarity index 84%
rename from src/main/java/net/minecraft/core/player/inventory/slot/ArmorSlot.java
rename to src/main/java/net/minecraft/core/player/inventory/slot/SlotArmor.java
index 727379d12..140076801 100644
--- a/src/main/java/net/minecraft/core/player/inventory/slot/ArmorSlot.java
+++ b/src/main/java/net/minecraft/core/player/inventory/slot/SlotArmor.java
@@ -6,16 +6,15 @@ import net.minecraft.core.item.IArmorItem;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
-import net.minecraft.core.item.block.BlockItem;
 import net.minecraft.core.item.material.ArmorMaterial;
-import net.minecraft.core.player.inventory.container.Inventory;
-import net.minecraft.core.player.inventory.menu.InventoryMenu;
+import net.minecraft.core.player.inventory.container.ContainerInventory;
+import net.minecraft.core.player.inventory.menu.MenuInventory;
 import net.minecraft.core.player.inventory.container.Container;
 
 import java.util.HashSet;
 import java.util.Set;
 
-public class ArmorSlot extends Slot
+public class SlotArmor extends Slot
 {
     public static String[] armorOutlines = new String[]{
         "minecraft:item/armor_boots_outline",
@@ -25,9 +24,9 @@ public class ArmorSlot extends Slot
     };
 
     final int armorType;
-    final InventoryMenu menu;
+    final MenuInventory menu;
 
-    public ArmorSlot(InventoryMenu menu, Container container, int index, int x, int y, int armorType)
+    public SlotArmor(MenuInventory menu, Container container, int index, int x, int y, int armorType)
     {
         super(container, index, x, y);
         this.menu = menu;
@@ -61,7 +60,7 @@ public class ArmorSlot extends Slot
         
         for (int i = 0; i < menu.slots.size(); i++)
         {
-        	if (menu.slots.get(i) instanceof ArmorSlot)
+        	if (menu.slots.get(i) instanceof SlotArmor)
         	{
         		ItemStack stack = menu.slots.get(i).getItem();
         		if (stack != null && (stack.itemID == Items.ARMOR_BOOTS_CHAINMAIL.id || stack.itemID == Items.ARMOR_HELMET_CHAINMAIL.id || stack.itemID == Items.ARMOR_CHESTPLATE_CHAINMAIL.id || stack.itemID == Items.ARMOR_LEGGINGS_CHAINMAIL.id))
@@ -85,8 +84,8 @@ public class ArmorSlot extends Slot
             menu.inventory.player.triggerAchievement(Achievements.ALL_ARMOR_TYPES);
         }
         
-        if (getItem() != null && container instanceof Inventory) {
-            Player player = ((Inventory) container).player;
+        if (getItem() != null && container instanceof ContainerInventory) {
+            Player player = ((ContainerInventory) container).player;
             player.world.playSoundAtEntity(player, player, "random.equip", 2f, 1f);
         }
     }
diff --git a/src/main/java/net/minecraft/core/player/inventory/slot/CreativeSlot.java b/src/main/java/net/minecraft/core/player/inventory/slot/SlotCreative.java
similarity index 90%
rename from src/main/java/net/minecraft/core/player/inventory/slot/CreativeSlot.java
rename to src/main/java/net/minecraft/core/player/inventory/slot/SlotCreative.java
index 089368bc7..2e089d1c0 100644
--- a/src/main/java/net/minecraft/core/player/inventory/slot/CreativeSlot.java
+++ b/src/main/java/net/minecraft/core/player/inventory/slot/SlotCreative.java
@@ -2,11 +2,11 @@ package net.minecraft.core.player.inventory.slot;
 
 import net.minecraft.core.item.ItemStack;
 
-public class CreativeSlot extends Slot
+public class SlotCreative extends Slot
 {
 	public ItemStack item;
 
-	public CreativeSlot(final int index, final int x, final int y, final ItemStack item)
+	public SlotCreative(final int index, final int x, final int y, final ItemStack item)
 	{
 		super(null, index, x, y);
 		this.item = item;
diff --git a/src/main/java/net/minecraft/core/player/inventory/slot/DyeSlot.java b/src/main/java/net/minecraft/core/player/inventory/slot/SlotDye.java
similarity index 83%
rename from src/main/java/net/minecraft/core/player/inventory/slot/DyeSlot.java
rename to src/main/java/net/minecraft/core/player/inventory/slot/SlotDye.java
index 141f358e9..d3a1ff49c 100644
--- a/src/main/java/net/minecraft/core/player/inventory/slot/DyeSlot.java
+++ b/src/main/java/net/minecraft/core/player/inventory/slot/SlotDye.java
@@ -4,9 +4,9 @@ import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.player.inventory.container.Container;
 
-public class DyeSlot extends Slot {
+public class SlotDye extends Slot {
 
-	public DyeSlot(final Container inventory, final int id, final int x, final int y) {
+	public SlotDye(final Container inventory, final int id, final int x, final int y) {
 		super(inventory, id, x, y);
 	}
 
diff --git a/src/main/java/net/minecraft/core/player/inventory/slot/FurnaceSlot.java b/src/main/java/net/minecraft/core/player/inventory/slot/SlotFurnace.java
similarity index 92%
rename from src/main/java/net/minecraft/core/player/inventory/slot/FurnaceSlot.java
rename to src/main/java/net/minecraft/core/player/inventory/slot/SlotFurnace.java
index 9374f1648..78be145f5 100644
--- a/src/main/java/net/minecraft/core/player/inventory/slot/FurnaceSlot.java
+++ b/src/main/java/net/minecraft/core/player/inventory/slot/SlotFurnace.java
@@ -11,10 +11,10 @@ import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.player.inventory.container.Container;
 
-public class FurnaceSlot extends Slot
+public class SlotFurnace extends Slot
 {
 
-    public FurnaceSlot(Player player, Container container, int index, int x, int y)
+    public SlotFurnace(Player player, Container container, int index, int x, int y)
     {
         super(container, index, x, y);
         thePlayer = player;
diff --git a/src/main/java/net/minecraft/core/player/inventory/slot/ResultSlot.java b/src/main/java/net/minecraft/core/player/inventory/slot/SlotResult.java
similarity index 79%
rename from src/main/java/net/minecraft/core/player/inventory/slot/ResultSlot.java
rename to src/main/java/net/minecraft/core/player/inventory/slot/SlotResult.java
index b9700428f..7ea7d9dea 100644
--- a/src/main/java/net/minecraft/core/player/inventory/slot/ResultSlot.java
+++ b/src/main/java/net/minecraft/core/player/inventory/slot/SlotResult.java
@@ -12,18 +12,18 @@ import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
-import net.minecraft.core.item.tool.HoeToolItem;
-import net.minecraft.core.item.tool.PickaxeToolItem;
-import net.minecraft.core.item.tool.SwordToolItem;
+import net.minecraft.core.item.tool.ItemToolHoe;
+import net.minecraft.core.item.tool.ItemToolPickaxe;
+import net.minecraft.core.item.tool.ItemToolSword;
 import net.minecraft.core.player.inventory.container.Container;
-import net.minecraft.core.player.inventory.container.CraftingContainer;
+import net.minecraft.core.player.inventory.container.ContainerCrafting;
 
-public class ResultSlot extends Slot
+public class SlotResult extends Slot
 {
 	private final Container craftSlots;
 	private Player thePlayer;
 
-    public ResultSlot(Player player, Container craftSlots, Container container, int index, int x, int y)
+    public SlotResult(Player player, Container craftSlots, Container container, int index, int x, int y)
     {
         super(container, index, x, y);
         thePlayer = player;
@@ -49,10 +49,10 @@ public class ResultSlot extends Slot
 		if(item.id == Items.BUCKET_ICECREAM.id) thePlayer.addStat(Achievements.CRAFT_ICECREAM, 1);
 		if(item.id == Items.FOOD_PUMPKIN_PIE.id) thePlayer.addStat(Achievements.CRAFT_PUMPKIN_PIE, 1);
 		if(item.id == Items.HANDCANNON_UNLOADED.id) thePlayer.addStat(Achievements.CRAFT_HANDCANNON, 1);
-		if(item instanceof HoeToolItem) thePlayer.addStat(Achievements.BUILD_HOE, 1);
-		if(item instanceof SwordToolItem) thePlayer.addStat(Achievements.BUILD_SWORD, 1);
-		if(item instanceof PickaxeToolItem) {
-			PickaxeToolItem itemToolPickaxe = (PickaxeToolItem) item;
+		if(item instanceof ItemToolHoe) thePlayer.addStat(Achievements.BUILD_HOE, 1);
+		if(item instanceof ItemToolSword) thePlayer.addStat(Achievements.BUILD_SWORD, 1);
+		if(item instanceof ItemToolPickaxe) {
+			ItemToolPickaxe itemToolPickaxe = (ItemToolPickaxe) item;
 
 			if(itemToolPickaxe.getMaterial().getMiningLevel() > 0) {
 				thePlayer.addStat(Achievements.BUILD_BETTER_PICKAXE, 1);
@@ -67,7 +67,7 @@ public class ResultSlot extends Slot
 			thePlayer.addStat(Achievements.REPAIR_ARMOR, 1);
 		}
 
-		Registries.RECIPES.onCraftResult((CraftingContainer) craftSlots);
+		Registries.RECIPES.onCraftResult((ContainerCrafting) craftSlots);
 	}
     
     @Override
diff --git a/src/main/java/net/minecraft/core/util/helper/GetMonsterSkinUrlThread.java b/src/main/java/net/minecraft/core/util/helper/GetMonsterSkinUrlThread.java
index 2ba9d9fba..570c875a8 100644
--- a/src/main/java/net/minecraft/core/util/helper/GetMonsterSkinUrlThread.java
+++ b/src/main/java/net/minecraft/core/util/helper/GetMonsterSkinUrlThread.java
@@ -5,7 +5,7 @@ import com.b100.json.element.JsonArray;
 import com.b100.json.element.JsonObject;
 import com.b100.utils.StringUtils;
 import com.mojang.logging.LogUtils;
-import net.minecraft.core.entity.monster.HumanMob;
+import net.minecraft.core.entity.monster.MobHuman;
 import org.slf4j.Logger;
 
 import java.util.Base64;
@@ -20,10 +20,10 @@ public class GetMonsterSkinUrlThread extends Thread{
 
 	private static final JsonParser jsonParser = new JsonParser();
 
-	private HumanMob monster;
+	private MobHuman monster;
 	private UUID uuid;
 
-	public GetMonsterSkinUrlThread(HumanMob monster) {
+	public GetMonsterSkinUrlThread(MobHuman monster) {
 		this.monster = monster;
 		
 		setDaemon(true);
diff --git a/src/main/java/net/minecraft/core/world/BlocksContainer.java b/src/main/java/net/minecraft/core/world/BlocksContainer.java
index be3934c8a..1ac98faea 100644
--- a/src/main/java/net/minecraft/core/world/BlocksContainer.java
+++ b/src/main/java/net/minecraft/core/world/BlocksContainer.java
@@ -1,8 +1,7 @@
 package net.minecraft.core.world;
 
-import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.entity.BlockEntity;
+import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.enums.LightLayer;
@@ -28,7 +27,7 @@ public class BlocksContainer implements WorldSource {
     }
 
 
-    public void setBlock(int x, int y, int z, int blockID, int blockMeta, BlockEntity entity) {
+    public void setBlock(int x, int y, int z, int blockID, int blockMeta, TileEntity entity) {
         blockEntryMap.put(new ChunkCoordinates(x, y, z), new BlockEntry(blockID, blockMeta, entity, x, y, z));
     }
 
@@ -60,10 +59,10 @@ public class BlocksContainer implements WorldSource {
     }
 
     @Override
-    public BlockEntity getBlockEntity(int x, int y, int z) {
+    public TileEntity getBlockEntity(int x, int y, int z) {
         ChunkCoordinates c = new ChunkCoordinates(x, y, z);
         if (blockEntryMap.containsKey(c)){
-            return blockEntryMap.get(c).blockEntity;
+            return blockEntryMap.get(c).tileEntity;
         }
         return world.getBlockEntity(x, y, z);
     }
@@ -140,14 +139,14 @@ public class BlocksContainer implements WorldSource {
         public final int blockID;
         public final int blockMeta;
         @Nullable
-        public final BlockEntity blockEntity;
+        public final TileEntity tileEntity;
         public final int x;
         public final int y;
         public final int z;
-        public BlockEntry(int blockID, int blockMeta, @Nullable BlockEntity blockEntity, int x, int y, int z){
+        public BlockEntry(int blockID, int blockMeta, @Nullable TileEntity tileEntity, int x, int y, int z){
             this.blockID = blockID;
             this.blockMeta = blockMeta;
-            this.blockEntity = blockEntity;
+            this.tileEntity = tileEntity;
             this.x = x;
             this.y = y;
             this.z = z;
diff --git a/src/main/java/net/minecraft/core/world/Explosion.java b/src/main/java/net/minecraft/core/world/Explosion.java
index 22116a10e..f48cd58b7 100644
--- a/src/main/java/net/minecraft/core/world/Explosion.java
+++ b/src/main/java/net/minecraft/core/world/Explosion.java
@@ -1,6 +1,6 @@
 package net.minecraft.core.world;
 
-import net.minecraft.core.block.entity.BlockEntity;
+import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.data.gamerule.GameRules;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.player.Player;
@@ -66,7 +66,7 @@ public class Explosion {
             int z = chunkposition.z;
             
             int id = worldObj.getBlockId(x, y, z);
-            BlockEntity blockEntity = worldObj.getBlockEntity(x, y, z);
+            TileEntity tileEntity = worldObj.getBlockEntity(x, y, z);
             if(particles) {
                 double xPos = (double) x + worldObj.rand.nextFloat();
                 double yPos = (double) y + worldObj.rand.nextFloat();
@@ -88,7 +88,7 @@ public class Explosion {
             }
             if(id > 0)
             {
-                Block.blocksList[id].dropBlockWithCause(worldObj, EnumDropCause.EXPLOSION, x, y, z, worldObj.getBlockMetadata(x, y, z), blockEntity, null);
+                Block.blocksList[id].dropBlockWithCause(worldObj, EnumDropCause.EXPLOSION, x, y, z, worldObj.getBlockMetadata(x, y, z), tileEntity, null);
                 worldObj.setBlockWithNotify(x, y, z, 0);
                 Block.blocksList[id].onBlockDestroyedByExplosion(worldObj, x, y, z);
             }
diff --git a/src/main/java/net/minecraft/core/world/ExplosionCannonball.java b/src/main/java/net/minecraft/core/world/ExplosionCannonball.java
index 4770942a2..8c6c0079b 100644
--- a/src/main/java/net/minecraft/core/world/ExplosionCannonball.java
+++ b/src/main/java/net/minecraft/core/world/ExplosionCannonball.java
@@ -1,6 +1,6 @@
 package net.minecraft.core.world;
 
-import net.minecraft.core.block.entity.BlockEntity;
+import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.sound.SoundCategory;
@@ -144,7 +144,7 @@ public class ExplosionCannonball extends Explosion{
             int y = chunkposition.y;
             int z = chunkposition.z;
             int i1 = worldObj.getBlockId(x, y, z);
-            BlockEntity blockEntity = worldObj.getBlockEntity(x, y, z);
+            TileEntity tileEntity = worldObj.getBlockEntity(x, y, z);
             if(flag)
             {
                 double d = (double)x + worldObj.rand.nextFloat();
@@ -172,7 +172,7 @@ public class ExplosionCannonball extends Explosion{
                     ||  Block.blocksList[i1].blockMaterial == Material.decoration
                     ||  Block.blocksList[i1].blockMaterial == Material.ice))
             {
-                Block.blocksList[i1].dropBlockWithCause(worldObj, EnumDropCause.EXPLOSION, x, y, z, worldObj.getBlockMetadata(x, y, z), blockEntity, null);
+                Block.blocksList[i1].dropBlockWithCause(worldObj, EnumDropCause.EXPLOSION, x, y, z, worldObj.getBlockMetadata(x, y, z), tileEntity, null);
                 worldObj.setBlockWithNotify(x, y, z, 0);
                 Block.blocksList[i1].onBlockDestroyedByExplosion(worldObj, x, y, z);
             }
diff --git a/src/main/java/net/minecraft/core/world/LevelListener.java b/src/main/java/net/minecraft/core/world/LevelListener.java
index 1ee3a7475..4ce7f728a 100644
--- a/src/main/java/net/minecraft/core/world/LevelListener.java
+++ b/src/main/java/net/minecraft/core/world/LevelListener.java
@@ -1,12 +1,12 @@
 package net.minecraft.core.world;
 
 // Referenced classes of package net.minecraft.src:
-//            Entity, BlockEntity, Player
+//            Entity, TileEntity, Player
 
 import net.minecraft.client.render.RenderGlobal;
+import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.player.Player;
-import net.minecraft.core.block.entity.BlockEntity;
 import net.minecraft.core.sound.SoundCategory;
 
 public interface LevelListener
@@ -81,7 +81,7 @@ public interface LevelListener
 
     void playStreamingMusic(String soundPath, String Author, int x, int y, int z);
 
-    void tileEntityChanged(int x, int y, int z, BlockEntity blockEntity);
+    void tileEntityChanged(int x, int y, int z, TileEntity tileEntity);
 
     void levelEvent(Player player, int id, int x, int y, int z, int data);
 }
diff --git a/src/main/java/net/minecraft/core/world/PortalHandler.java b/src/main/java/net/minecraft/core/world/PortalHandler.java
index bc4ccc125..b15826afa 100644
--- a/src/main/java/net/minecraft/core/world/PortalHandler.java
+++ b/src/main/java/net/minecraft/core/world/PortalHandler.java
@@ -1,10 +1,10 @@
 package net.minecraft.core.world;
 
+import net.minecraft.core.block.BlockPortal;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.PortalBlock;
 import net.minecraft.core.world.type.WorldType;
 import org.jetbrains.annotations.Nullable;
 
@@ -12,7 +12,7 @@ import java.util.Random;
 
 // Referenced classes of package net.minecraft.src:
 //            Entity, MathHelper, World, Block, 
-//            PortalBlock, Material
+//            BlockPortal, Material
 
 public class PortalHandler
 {
@@ -77,7 +77,7 @@ public class PortalHandler
                         continue;
                     }
 
-                    if (portalColor != null && targetPortalId > 0 && ((PortalBlock)Block.getBlock(targetPortalId)).getColor(world, dx, dy, dz) != portalColor) {
+                    if (portalColor != null && targetPortalId > 0 && ((BlockPortal)Block.getBlock(targetPortalId)).getColor(world, dx, dy, dz) != portalColor) {
                         continue;
                     }
                     
@@ -112,7 +112,7 @@ public class PortalHandler
                             continue;
                         }
 
-                        if (portalColor != null && targetPortalId > 0 && ((PortalBlock) Block.getBlock(targetPortalId)).getColor(world, dx, dy, dz) != portalColor) {
+                        if (portalColor != null && targetPortalId > 0 && ((BlockPortal) Block.getBlock(targetPortalId)).getColor(world, dx, dy, dz) != portalColor) {
                             continue;
                         }
 
@@ -196,12 +196,12 @@ public class PortalHandler
         
         if (newDim.homeDim == null)
         {
-        	targetPortalFrameId = ((PortalBlock) Block.blocksList[oldDim.portalBlockId]).portalFrameId;
+        	targetPortalFrameId = ((BlockPortal) Block.blocksList[oldDim.portalBlockId]).portalFrameId;
         	targetPortalId = oldDim.portalBlockId;
         }
         else
         {
-        	targetPortalFrameId = ((PortalBlock)Block.blocksList[newDim.portalBlockId]).portalFrameId;
+        	targetPortalFrameId = ((BlockPortal)Block.blocksList[newDim.portalBlockId]).portalFrameId;
         	targetPortalId = newDim.portalBlockId;
         }
         
@@ -367,7 +367,7 @@ label1:
 
             }
             
-            ((PortalBlock)Block.blocksList[targetPortalId]).tryToCreatePortal(world, portalX,  portalY,  portalZ, portalColor);
+            ((BlockPortal)Block.blocksList[targetPortalId]).tryToCreatePortal(world, portalX,  portalY,  portalZ, portalColor);
 
             world.noNeighborUpdate = false;
             for(int k6 = 0; k6 < 4; k6++)
diff --git a/src/main/java/net/minecraft/core/world/SpawnerMobs.java b/src/main/java/net/minecraft/core/world/SpawnerMobs.java
index 59e1f0af1..769400fd3 100644
--- a/src/main/java/net/minecraft/core/world/SpawnerMobs.java
+++ b/src/main/java/net/minecraft/core/world/SpawnerMobs.java
@@ -1,16 +1,16 @@
 package net.minecraft.core.world;
 
 import com.mojang.logging.LogUtils;
-import net.minecraft.core.block.BedBlock;
+import net.minecraft.core.block.BlockBed;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.data.gamerule.GameRules;
 import net.minecraft.core.entity.EntityDispatcher;
 import net.minecraft.core.entity.Mob;
 import net.minecraft.core.entity.SpawnListEntry;
-import net.minecraft.core.entity.monster.SkeletonMob;
-import net.minecraft.core.entity.monster.ZombieArmoredMob;
-import net.minecraft.core.entity.monster.SpiderMob;
-import net.minecraft.core.entity.monster.ZombieMob;
+import net.minecraft.core.entity.monster.MobSkeleton;
+import net.minecraft.core.entity.monster.MobSpider;
+import net.minecraft.core.entity.monster.MobZombieArmored;
+import net.minecraft.core.entity.monster.MobZombie;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.MobCategory;
 import net.minecraft.core.util.helper.MathHelper;
@@ -26,12 +26,8 @@ import net.minecraft.core.world.pathfinder.Path;
 import net.minecraft.core.world.pathfinder.PathFinder;
 import org.slf4j.Logger;
 
-import java.util.Collection;
-import java.util.HashMap;
 import java.util.HashSet;
 import java.util.List;
-import java.util.Locale;
-import java.util.Map;
 import java.util.Set;
 public final class SpawnerMobs
 {
@@ -42,7 +38,7 @@ public final class SpawnerMobs
     static
     {
         nightSpawnEntities = new Class[] {
-            SpiderMob.class, ZombieMob.class, SkeletonMob.class, ZombieArmoredMob.class
+            MobSpider.class, MobZombie.class, MobSkeleton.class, MobZombieArmored.class
         };
     }
 
@@ -290,7 +286,7 @@ public final class SpawnerMobs
 								Node pathPoint = pathEntity.last();
                                 boolean isCollisionFree = world.checkBlockCollisionBetweenPoints(Vec3.getTempVec3(player.x, player.y + 1.5f, player.z), Vec3.getTempVec3(pathPoint.x, pathPoint.y + 1.5f, pathPoint.z)) == null;
 								if(Math.abs(pathPoint.x + 0.5f - player.x) < 1.5 && Math.abs(pathPoint.z + 0.5f - player.z) < 1.5 && Math.abs(pathPoint.y + 0.5f - player.y) < 1.5 && isCollisionFree) {
-									ChunkCoordinates pos = BedBlock.getNearestEmptyChunkCoordinates(world, MathHelper.floor(player.x), MathHelper.floor(player.y), MathHelper.floor(player.z), 1);
+									ChunkCoordinates pos = BlockBed.getNearestEmptyChunkCoordinates(world, MathHelper.floor(player.x), MathHelper.floor(player.y), MathHelper.floor(player.z), 1);
 									if(pos == null) {
 										pos = new ChunkCoordinates(x, spawnY + 1, z);
 									}
